<template>
  <div layout="films dashboard" class="fdv__container">
    <div class="fdv__search-container">
      <input
        v-show="showSearching"
        ref="search"
        v-model="searchFilter"
        type="text"
        autofocus
        class="fdv__search"
        @input="handleSearch"
      >
      <suggestions-component v-if="showSuggestion" :suggestions="suggestions" />
    </div>
    <help-component v-if="showHelp" />
    <transition-group name="list" tag="div" class="fdv__grid-container">
      <poster-component
        v-for="(doc, index) in docs"
        :key="`${index}-${getImg(doc)}`"
        :index="index"
        :total="docs.length"
        :alt="getAlt(doc)"
        :src="getImg(doc)"
        :doc="doc"/>
    </transition-group>
  </div>
</template>

<script>
import get from 'lodash/get';
import uniq from 'lodash/uniq';
import flatten from 'lodash/flatten';
import debounce from 'lodash/debounce';
import PouchDB from 'pouchdb';
import PouchDBFind from 'pouchdb-find';
import { EMPTY_STRING } from '@/common/helpers/constants';
import PosterComponent from '@dashboard/components/Poster.vue';
import HelpComponent from '@dashboard/components/Help.vue';
import SuggestionsComponent from '@dashboard/components/Suggestions.vue';

PouchDB.plugin(PouchDBFind);

export default {
  name: 'DashboardLayout',
  components: { HelpComponent, SuggestionsComponent, PosterComponent },
  data() {
    return {
      db: null,
      docs: [],
      searchFilter: EMPTY_STRING,
      showSearching: true,
      showSuggestion: false,
      showHelp: false,
      compType: {},
      regex: {
        any: new RegExp(/!any\s(.*$)/),
        actor: new RegExp(/!actor\s(.*$)/),
        genre: new RegExp(/!genre\s(.*$)/),
        director: new RegExp(/!director\s(.*$)/),
      },
    };
  },
  computed: {
    suggestions() {
      if (this.regex.any.test(this.searchFilter) || !this.searchFilter.match(/^!/)) {
        return this.docs.length
          ? this.docs.map(doc => get(doc, 'movie.title', EMPTY_STRING))
          : [];
      } else if (this.regex.actor.test(this.searchFilter)) {
        const actors = this.docs.map(doc => get(doc, 'movie.actor', []).map(a => a.name));
        return uniq(flatten(actors));
      } else if (this.regex.director.test(this.searchFilter)) {
        const directors = this.docs.map(doc => get(doc, 'movie.director', []));
        return uniq(flatten(directors));
      } else if (this.regex.genre.test(this.searchFilter)) {
        const genres = this.docs.map(doc => get(doc, 'movie.genre', []));
        return uniq(flatten(genres));
      }
      return [];
    },
  },
  destroyed() {
    this.db.close();
    document.removeEventListener('keypress', this.haandleKeys);
  },
  async mounted() {
    this.db = new PouchDB('films');
    await this.db.createIndex({ index: { fields: ['movie.actor.name'] } });
    await this.db.createIndex({ index: { fields: ['movie.director'] } });
    await this.db.createIndex({ index: { fields: ['movie.genre'] } });
    await this.db.createIndex({ index: { fields: ['movie.title'] } });
    this.docs = await this.dbGetUntil(100);
    document.addEventListener('keydown', this.haandleKeys);
  },
  methods: {
    haandleKeys(ev) {
      // console.log(ev);
      if (ev.altKey && ev.metaKey && ev.keyCode === 70) { // 70 === f
        this.showSearching = !this.showSearching;
        if (this.showSearching) this.$nextTick(() => this.$refs.search.focus());
      }
      if (ev.altKey && ev.metaKey && ev.keyCode === 83) { // 83 === s
        this.showSuggestion = !this.showSuggestion;
      }
      if (ev.altKey && ev.metaKey && ev.keyCode === 72) { // 72 === h
        this.showHelp = !this.showHelp;
      }
      if (ev.altKey && ev.metaKey && ev.keyCode === 66) { // 66 === b
        this.$router.push({ name: 'Builder', query: { delete: true } });
      }
    },
    handleSearch: debounce(async function() {
      if (!this.searchFilter.length) {
        this.docs = await this.dbGetUntil(100);
        return;
      }
      if (this.regex.actor.test(this.searchFilter)) {
        this.dbActorFilter();
      } else if (this.regex.genre.test(this.searchFilter)) {
        this.dbGenreFilter();
      } else if (this.regex.director.test(this.searchFilter)) {
        this.dbDirectorFilter();
      } else if (this.regex.any.test(this.searchFilter)) {
        this.dbTitleAnyFilter();
      } else if (!this.searchFilter.match(/^!/)) {
        this.dbTitleFilter();
      }
    }, 600),
    async dbGenreFilter() {
      const rxResult = this.searchFilter.match(this.regex.genre);
      const genre = get(rxResult, '[1]', EMPTY_STRING);
      if (!genre) return;

      const localDocsFiltered = this.docs.filter(doc => {
        const dir = get(doc, 'movie.genre', EMPTY_STRING);
        return Array.isArray(dir)
          ? dir.some(d => d.toLowerCase().includes(genre.toLowerCase()))
          : dir.toLowerCase().includes(genre.toLowerCase());
      });
      if (localDocsFiltered.length) {
        this.docs = localDocsFiltered;
      }

      const { docs } = await this.db.find({
        selector: {
          'movie.genre': { $regex: new RegExp(genre, 'i') },
        },
      });
      if (docs.length) {
        this.docs = docs;
      } else {
        this.docs = [];
      }
    },
    async dbDirectorFilter() {
      const rxResult = this.searchFilter.match(this.regex.director);
      const director = get(rxResult, '[1]', EMPTY_STRING);
      if (!director) return;
      const localDocsFiltered = this.docs.filter(doc => {
        const dir = get(doc, 'movie.director', EMPTY_STRING);
        return Array.isArray(dir)
          ? dir.some(d => d.toLowerCase().includes(director.toLowerCase()))
          : dir.toLowerCase().includes(director.toLowerCase());
      });
      if (localDocsFiltered.length) {
        this.docs = localDocsFiltered;
      }

      const { docs } = await this.db.find({
        selector: {
          'movie.director': { $regex: new RegExp(director, 'i') },
        },
      });
      if (docs.length) {
        this.docs = docs;
      } else {
        this.docs = [];
      }
    },
    async dbActorFilter() {
      const rxResult = this.searchFilter.match(this.regex.actor);
      const actor = get(rxResult, '[1]', EMPTY_STRING);
      if (!actor) return;

      const localDocsFiltered = this.docs.filter(doc => doc.movie.actor
        .some(a => a.name.toLowerCase().includes(actor.toLowerCase())));
      if (localDocsFiltered.length) {
        this.docs = localDocsFiltered;
      }

      const { docs } = await this.db.find({
        selector: {
          'movie.actor': {
            $elemMatch: { name: { $regex: new RegExp(actor, 'i') } },
          },
        },
      });
      if (docs.length) {
        this.docs = docs;
      } else {
        this.docs = [];
      }
    },
    async dbTitleAnyFilter() {
      const rxResult = this.searchFilter.match(this.regex.any);
      const title = get(rxResult, '[1]', EMPTY_STRING);
      if (!title) return;

      const localDocsFiltered = this.docs.filter(doc => doc.movie.title.toLowerCase()
        .includes(title.toLowerCase()));
      if (localDocsFiltered.length) {
        this.docs = localDocsFiltered;
      }
      const { docs } = await this.db.find({
        selector: {
          'movie.title': { $regex: new RegExp(title, 'i') },
        },
      });
      if (docs.length) {
        this.docs = docs;
      } else {
        this.docs = [];
      }
    },
    async dbTitleFilter() {
      const rg = new RegExp(`^${this.searchFilter}`, 'i');
      const localDocsFiltered = this.docs.filter(doc => rg.test(doc.movie));
      if (localDocsFiltered.length) {
        this.docs = localDocsFiltered;
      }
      const { docs } = await this.db.find({
        selector: {
          'movie.title': { $regex: rg },
        },
      });
      if (docs.length) {
        this.docs = docs;
        // this.suggestions = docs.map(doc => get(doc, 'movie.title', EMPTY_STRING));
      } else {
        this.docs = [];
      }
    },
    async dbGetUntil(limit) {
      const { docs } = await this.db.find({
        selector: {
          'movie.title': { $gte: null },
        },
        sort: ['movie.title'],
        limit: limit,
      });
      return docs;
    },
    getAlt(doc) {
      return get(doc, 'movie.title', EMPTY_STRING);
    },
    getMovie(doc) {
      return get(doc, 'movie', EMPTY_STRING);
    },
    getImg(doc) {
      const image = doc.files.images.find(file => file.fullPath.includes('-poster.'));
      const fullPath = get(image, 'fullPath', EMPTY_STRING);
      if (!fullPath) return EMPTY_STRING;
      const img = fullPath.replace(
        '/Volumes/almacen/VIDEO/PELICULAS',
        // Buscar otro modo para poder leer las constantes
        'http://localhost:3000',
      );
      return img;
    },
  },
};
</script>

<style lang="scss" scoped>
.fdv__container {
  display: flex;
  flex-direction: column;
  width: 100%;
  height: 100%;
}

.fdv__search-container {
  z-index: 3;
  position: fixed;
  width: 100%;
  display: flex;
  justify-content: center;
  height: 5%;
  flex-shrink: 0;
  margin: 0.5rem;
}

.fdv__grid-container {
  width: 100%;
  display: flex;
  flex-wrap: wrap;
}

.fdv__search {
  width: 75%;
  border-radius: 25px;
  font-size: 1.5rem;
  color: grey;
  padding: 0.5rem;
  border-style: solid;
  border: solid 1px #dcdbdb;
}

input:focus {
  outline: none;
}

.list-enter-active, .list-leave-active {
  transition: all 1s;
}
.list-enter, .list-leave-to /* .list-leave-active below version 2.1.8 */ {
  opacity: 0;
  transform: translateY(30px);
}
</style>
